/*
* Casey Burkhardt
* CSC 1051-002 - Algorithms and Data Structures I
* UserInfo.java
* Due: 10/02/2007
* Description: Generates a username and password using a given algorithm based on input of first and last names.
*/

//Import Necessary Classes
import java.util.Scanner;
import java.util.Random;

public class UserInfo
{
	public static void main (String[] args)
	{
		// Declare Scanner Object
		Scanner scan = new Scanner (System.in);
		
		// Declare Random Object
		Random generator = new Random();

		// Declaration Statements
		// Input
		String firstName, lastName;

		// Process
		int iterations, randomNumber;

		// Output
		String userName, password;
		
		// Obtain Number of Iterations
		System.out.println("User Info Generation Test Program");
		System.out.print("Enter Number of Test Cases: ");
		iterations = scan.nextInt();
				
		// Create Looping Structure
		for(int i=0; i < iterations; i++)
		{
			// Java contains a bug which occurs when a string is imported
			// directly after an integer.  To correct this, a line of junk
			// is read in to offset this on the first iteration of the loop.
			if(i==0)
				scan.nextLine();
			
			// Obtain User Data For This Test Case
			System.out.print("Enter First Name: ");
			firstName = scan.nextLine();
			
			System.out.print("Enter Last Name: ");
			lastName = scan.nextLine();
			
			// Process Algorithm to Create Username
			// First Two Characters of First Name
			userName = firstName.substring(0,2);
			// First Four Characters of Last Name
			userName = userName + lastName.substring(0,4);
			// Random Integer Between 2 and 8 - Repeated Once
			randomNumber = generator.nextInt(7) + 2;
			userName = userName + randomNumber + randomNumber;
			// All Uppercase
			userName = userName.toUpperCase();
			
			// Process Algorithm to Create Password
			// First Character of Last Name
			password = lastName.substring(0,1);
			// Concatenate First Name and Last Name, Minus First Character
			password = password + firstName + lastName.substring(1,lastName.length());
			// Substitute 'e's with '3's and 'i's with '1's.
			password = password.replace('e', '3');
			password = password.replace('i', '1');
			// Replace 3rd Character With a Random Number 1 - 9
			randomNumber = generator.nextInt(9) + 1;
			password = password.substring(0,2) + randomNumber + password.substring(3,password.length());
			// Trim To Six Characters
			password = password.substring(0,6);

			// Output
			System.out.println("\nUsername: " + userName + "\tPassword: " + password + "\n");
		}
	// Display Closing Message
	System.out.println("End of User Info Generation Test Program");
	}
}